package com.isu.gaswellwatch.modbus.data.decode.impl.weps;


import com.isu.gaswellwatch.modbus.data.ModbusMessage;
import com.isu.gaswellwatch.modbus.data.decode.DecodeHandler;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.math.NumberUtils;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * @author <a href="mailto:shilong.wang@alpha-ess.com">王仕龙</a>
 * 2025/2/22 00:50
 */
@Component(WepsDecimalDecodeHandler.NAME + DecodeHandler.DECODE_NAME)
public class WepsDecimalDecodeHandler implements DecodeHandler {

    public static final String NAME = "wepsDecimal";

    @Override
    public String decode(Map<String, Object> commandPointMap, String value) {
        if (StringUtils.isBlank(value)) {
            return value;
        }
        if (StringUtils.startsWith(value, ".")) {
            return NumberUtils.createBigDecimal("0" + value).toString();
        } else if (StringUtils.endsWith(value, ".")) {
            return NumberUtils.createBigDecimal(value + "0").toString();
        } else {
            return value;
        }
    }

    @Override
    public void decode(Map<String, Object> commandPointMap, ModbusMessage.MessagePoint point) {
        point.setValue(this.decode(commandPointMap, point.getValue()));
    }

}
